#!/usr/bin/perl

use LWP::Simple;
use strict;
if(scalar(@ARGV)<1)
{
	print STDERR "usage: verifyFeed [FEED URLS]\n";
	exit;
}

foreach my $feed (@ARGV)
{
	print "$feed\n";
	$feed=~s/\/$//;

	my $packages=LWP::Simple::get("$feed/Packages");
	my $index=LWP::Simple::get("$feed/");
	my %listed;
	
	if($packages)
	{
		my @files=$packages=~m/filename\s*:\s*(.*)\s*/gi;

		my $valid=1;
		foreach my $file (@files)
		{
			my ($content_type, $document_length, $modified_time, $expires, $server)=LWP::Simple::head("$feed/$file");
			if(!$content_type)
			{
				print "Missing\t";
			}
			elsif(!$document_length)
			{
				print "Empty\t";
			}
			else
			{
				$listed{$file}=1;
				print "Valid\t";
			}
			print "$feed/$file\n";
		}
		print "\n";
	}
	else
	{
		print "Error, No Package List\n";
	}

	if($index)
	{
		my @files=$index=~m/<a href="(.*?\.ipk)"/gi;	
		foreach my $file (@files)
		{
			if(!$listed{$file})
			{
				print "Extra\t$feed/$file\n";
			}
		}
		print "\n";
	}
	else
	{
		print "Error, Unable to get index list\n";
	}
}
